/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qstring.h>
#include <qptrlist.h>
#include <kdebug.h>

void IncomingDialog::init()
{
    kdDebug() << "IncomingDialog::init()" << endl;
    
    listCalls->addColumn("CallNr",100);
    callIdCol = listCalls->addColumn("CallId");
}

void IncomingDialog::newCall(QString callid)
{
    kdDebug() << "IncomingDialog::newCall()" << endl;
    
    callsInList += callid;
    
    KListViewItem newcalltmp = new KListViewItem(listCalls,"phonenr",callid);
    listCalls->insertItem(&newcalltmp);
}

void IncomingDialog::acceptCall()
{
    kdDebug() << "IncomingDialog::acceptCall()" << endl;
    
    QPtrList <QListViewItem> selectedCalls;
    selectedCalls = listCalls->selectedItems();
    
    QListViewItem *call;
    for ( call = selectedCalls.first(); call; call = selectedCalls.next() )
    {
        QString tmpCallId = call->text(callIdCol);
        emit accept(tmpCallId);        
    }
}

void IncomingDialog::rejectCall()
{
    kdDebug() << "IncomingDialog::rejectCall()" << endl;
    
    QPtrList <QListViewItem> selectedCalls;
    selectedCalls = listCalls->selectedItems();
    
    QListViewItem *call;
    for ( call = selectedCalls.first(); call; call = selectedCalls.next() )
    {
        QString tmpCallId = call->text(callIdCol);
        emit reject(tmpCallId);
        
        listCalls->takeItem(call);
    }
    
    if(listCalls->childCount() == 0)
    {
        this->hide();
    }
}

void IncomingDialog::hangupCall()
{
    kdDebug() << "IncomingDialog::hangupCall()" << endl;
    
    QPtrList <QListViewItem> selectedCalls;
    selectedCalls = listCalls->selectedItems();
    
    QListViewItem *call;
    for ( call = selectedCalls.first(); call; call = selectedCalls.next() )
    {
        QString tmpCallId = call->text(callIdCol);
        emit hangup(tmpCallId);
        
        listCalls->takeItem(call);
    }
    
    if(listCalls->childCount() == 0)
    {
        this->hide();
    }
}

void IncomingDialog::cancelCall(QString callId)
{
    kdDebug() << "IncomingDialog::cancelCall()" << endl;
    
    QListViewItem *call; 
    call = listCalls->findItem(callId, callIdCol);
    
    if(call != 0)
    {
        listCalls->takeItem(call);
    }
    
    if(listCalls->childCount() == 0)
    {
        this->hide();
    }
}


void IncomingDialog::dialNr()
{
    kdDebug() << "IncomingDialog::dialNr()" << endl;
    
    emit dial();
}
