#ifndef _KCALL_H_
#define _KCALL_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <ksystemtray.h>
#include <qpixmap.h>

class QTimer;
class KCallCore;
class IncomingDialog;

class KCall : public KSystemTray
{
    Q_OBJECT
    public:
        KCall();
        virtual ~KCall();

        void mousePressEvent(QMouseEvent *event);
        void showDialList(QMouseEvent *pos);
        void showMainMenu(QMouseEvent *pos);

    protected:
        void paintGui();
        void openDialList();
        void startBlink( const QPixmap &iconOn, const QPixmap &iconOff );
        void stopBlink();

        IncomingDialog *incomingdlg;
        KCallCore *mkcall;

        QString onlineIcon;
        QString offlineIcon;
        QString bellIcon;
        QString regButtonText;

        bool kCallGuiRunning;

        bool m_isBlinking;
        bool m_isBlinkIcon;
        QPixmap m_blinkIconOn;
        QPixmap m_blinkIconOff;
        QTimer *m_blinkTimer;

    protected slots:
        void slotBlink();

    public slots:
        void slotOpenKCall();
        void slotHelp();
        void slotPreferences();
        void slotAbout();
        void slotDialDlg();
        void slotStartIncomingCall(QString callid, QString caller, QString subject);
        void slotStopIncomingCall(QString callid);
        void slotRegistrationChanged( int newstatus );
        void slotUnRegistrate();
        void slotSettingsChanged();
        void acceptCall(QString callId);
        void rejectCall(QString callId);
        void hangupCall(QString callId);
        void slotQuit();
        void guiStatus(bool s);
};

#endif // _KCALL_H_
