#include "kcall.h"
#include <kuniqueapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <kwin.h>
#include <kstartupinfo.h>
#include <kdebug.h>

static const char description[] =
    I18N_NOOP("Phone Applet");

static const char version[] = "0.1";

static KCmdLineOptions options[] =
{
	  {"dial <number>",I18N_NOOP( "Init a call to the Number" ),0},
    KCmdLineLastOption
};

int main(int argc, char **argv)
{
    KAboutData about("kcallapplet", I18N_NOOP("kcallapplet"), version, description,
		     KAboutData::License_LGPL, "(C) 2005 Mike Hauth", 0, 0, "mike@mike-hauth.de");
    about.addAuthor( "Eva Brucherseifer", 0, "eva.brucherseifer@basyskom.de" );
    about.addAuthor( "Mike Hauth", 0, "mike@mike-hauth.de" );
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KUniqueApplication::addCmdLineOptions();	
	
	KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
    QCString dialOptionArg = args->getOption("dial");
	
    
    KUniqueApplication app;
	
    KCall kcall;
    KWin::setSystemTrayWindowFor(kcall.winId(), 0);
    kcall.show();
	
    app.setTopWidget(&kcall);
    KStartupInfo::appStarted();

    return app.exec();  
}
