#include "diallistreadonly.h"
#include "kcallguiconst.h"

#include <kdebug.h>
#include <kstandarddirs.h>

#include <qstring.h>
#include <qdom.h>
#include <qvaluelist.h>
#include <qfile.h>
#include <qdatetime.h>


DialListReadOnly::DialListReadOnly(unsigned int ml)
{
    kdDebug() << "DialListReadOnly::DialListReadOnly()" << endl;
    dlFilename = KGlobal::dirs()->localkdedir() + "share/apps/kcallapplet/calllist.lst";
    kdDebug() << "--- LIST FILENAME: " << dlFilename << endl;
    //dlFilename = locateLocal("appdata", "calllist.lst");
    maxlength  = ml;
}

DialListReadOnly::~DialListReadOnly()
{
    kdDebug() << "DialListReadOnly::~DialListReadOnly()" << endl;
}

void DialListReadOnly::load()
{
    kdDebug() << "DialListReadOnly::load()" << endl;
    
    openList();
}


QValueList<call> DialListReadOnly::getAllCalls()
{
    kdDebug() << "DialListReadOnly::getAllCalls()" << endl;
    
    return calls;
}

QValueList<call> DialListReadOnly::getLastCalls(unsigned int count)
{
    kdDebug() << "DialListReadOnly::getLastCalls()" << endl;
    
    return lastcalls;
}

void DialListReadOnly::openList()
{
    kdDebug() << "dialList::openList()" << endl;
    QString filename = dlFilename;  
    lastcalls.clear();
    calls.clear();
    
    
    QDomDocument doc("KCallCalls");
    QFile f(filename);
    if (!f.open(IO_ReadOnly))
    {    
    }
    if (!doc.setContent(&f)) 
    {
        f.close();
    }
    f.close();
    
    QDomNodeList domCalls = doc.elementsByTagName("call");
    for(uint i=0;i<domCalls.count();++i) {
        QDomElement c = domCalls.item(i).toElement();
        if (!c.isNull()) {
            loadCall(&c);
        }
    }
}

void DialListReadOnly::loadCall(QDomElement *c)
{
    kdDebug() << "dialList::loadCall()" << endl;
    
    QString callId = c->attribute("callid","");
    QString callerNr = c->attribute("callernr","");
    QString callerName = c->attribute("callername","");
    QString subject = c->attribute("subject","");
    int type = (c->attribute("type","")).toInt();
    QDate date = QDate::fromString(c->attribute("date"));
    QTime time = QTime::fromString(c->attribute("time"));
    int duration = (c->attribute("duration","0")).toInt();
    
    reInsertCall(callId, callerNr, callerName, subject, type, date, time, duration);
    
}

void DialListReadOnly::reInsertCall(QString callId, QString callerNr, QString callerName, QString subject, int type, QDate date, QTime time, int duration)
{
    kdDebug() << "dialList::reInsertCall()" << endl;
    
    call callTemp;
    
    callTemp.callId = callId;
    callTemp.callerNr = callerNr;
    callTemp.callerName = callerName;
    callTemp.subject = subject;
    callTemp.type = type;
    callTemp.date = date;
    callTemp.time = time;
    callTemp.duration = duration;
        
    bool exist = false;
    
    for(unsigned int i = 0; i < lastcalls.size(); i++)
    {
        if(lastcalls[i].callerNr == callTemp.callerNr)
        {
            exist = true;
        }
    }
    
    if(exist == false)
    {
        if(maxlength <= lastcalls.size())
        {    
            lastcalls.pop_front();
        }
        
        lastcalls.push_back(callTemp);
    }
    
    calls.push_front(callTemp);
}
