
#ifndef _KCALLGUIPART_H_
#define _KCALLGUIPART_H_

#include <kparts/part.h>
#include <kparts/factory.h>


class QWidget;
class QPainter;
class KURL;
class QMultiLineEdit;
class KCallGuiCore;
class KCallGuiMain;

class KCallGuiPart : public KParts::ReadWritePart
{
    Q_OBJECT
    
    public:
        KCallGuiPart(QWidget *parentWidget, const char *widgetName, QObject *parent, const char *name);
        virtual ~KCallGuiPart();
        virtual void setReadWrite(bool rw);
        virtual void setModified(bool modified);

    protected:
        virtual bool openFile();
        virtual bool saveFile();
    
    private:
        void initMainWidget();
        
        QMultiLineEdit *m_widget;
        KCallGuiMain *mainWidget;
        bool kCallStatus;
        KCallGuiCore *mGuiCore;
     
    public slots:
        void fileOpen();
        void fileSaveAs();
        void configure();
};





class KInstance;
class KAboutData;

class KCallGuiPartFactory : public KParts::Factory
{
    Q_OBJECT
    public:
        KCallGuiPartFactory();
        virtual ~KCallGuiPartFactory();
        virtual KParts::Part* createPartObject( QWidget *parentWidget, const char *widgetName,
                                                QObject *parent, const char *name,
                                                const char *classname, const QStringList &args );
        static KInstance* instance();
    
    private:
        static KInstance* s_instance;
        static KAboutData* s_about;
};

#endif // _KCALLGUIPART_H_
