#ifndef _KCALLGUICORE_H_
#define _KCALLGUICORE_H_

#include <dcopobject.h>
#include <dcopclient.h>

class KCallGuiPart;
class KCallGuiMain;

class KCallGuiCore : public QObject, public DCOPObject
{
    K_DCOP
    Q_OBJECT
    
    public:
        KCallGuiCore(KCallGuiPart* part, KCallGuiMain* widget);
        virtual ~KCallGuiCore();
        
        bool getKCallStatus();
            
    protected:
        bool registrateAtKCall(bool);
    
        DCOPClient *dcopClient;
        KCallGuiPart *pKCallPart;
        KCallGuiMain *pKCallGui;
        bool kCallStatus;
    
    k_dcop:   
        void kCallStatusReport( bool online );
        void newCall(QString callid, QString caller, QString subject, int status);
        void cancelCall(QString callid);
        void showSettingsDialog();
        
    public slots:
        void acceptCall(QString);
        void holdCall(QString);
        void rejectCall(QString);
        void hangupCall(QString);
        QString dial(QString num);
        void loadSettings();
};
#endif
