/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <kdebug.h>
#include <kabc/addressee.h>
#include <kurllabel.h>
#include <qobjectlist.h>

void PhoneNrWidget::init()
{
    kdDebug() << "phoneNr::init()" << endl;

    labelLayout = new QVBoxLayout( phoneNrLabelFrame );
    nrLayout    = new QVBoxLayout( phoneNrFrame );
}

void PhoneNrWidget::setPhoneNrs(KABC::Addressee person)
{
    kdDebug() << "phoneNr::setPhoneNrs()" << endl;
   
    QLabel *label;
    for ( label = labels.first(); label; label = labels.next() ){
        kdDebug() << "Loeschen:" << label->text() << endl;
        delete label;
    }
    labels.clear();
    
    KURLLabel *nr;
    for ( nr = nrs.first(); nr; nr = nrs.next() ){
        kdDebug() << "Loeschen:" << nr->text() << endl;
        delete nr;
    }
    
    nrs.clear();
    show();    
        
    KABC::PhoneNumber::List nrList = person.phoneNumbers();
    KABC::PhoneNumber::List::Iterator phoneIter;
    
    for ( phoneIter = nrList.begin(); phoneIter != nrList.end(); ++phoneIter) 
    {
        kdDebug() << "Label:"<< (*phoneIter).typeLabel() << endl;
        kdDebug() << "Nr:"<< (*phoneIter).number() << endl;
                
        QLabel *tmpLabel = new QLabel( phoneNrLabelFrame );
        labelLayout->addWidget(tmpLabel);
        tmpLabel->show();
        
        tmpLabel->setText((*phoneIter).typeLabel());
        tmpLabel->setAlignment( AlignRight );
        
        labels.append(tmpLabel);
        
        KURLLabel *tmpNr = new KURLLabel( phoneNrFrame );
        connect(tmpNr, SIGNAL(leftClickedURL(const QString&)),this, SLOT(dial(const QString&)));
        nrLayout->addWidget(tmpNr);
        tmpNr->show();
        
        tmpNr->setText((*phoneIter).number());
        tmpNr->setURL((*phoneIter).number());
        tmpNr->setAlignment( AlignLeft );
        
        nrs.append(tmpNr);
        
    } 
    phoneNrLabelFrame->show();
    phoneNrFrame->show();
}

void PhoneNrWidget::dial( const QString &nr )
{
    kdDebug() << "PhoneNrWidget::dial()" << endl;

    emit dialNr( nr );
}
