/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include <kdebug.h>
#include <kabc/addressee.h>
#include <kabc/address.h>
#include <kabc/picture.h>
#include <kurllabel.h>
#include <kglobal.h>
#include <kiconloader.h>

#include "phonenrwidget.h"

void VisCard::init()
{
    kdDebug() << "VisCard::setByAddressee()" << endl;
    
    callHistory->addColumn("Date");
    callHistory->addColumn("callId",0);
    
    phNrLayout = new QVBoxLayout( phoneNrFrame, 11, 6, "phNrLayout");
    phoneNrWid = new PhoneNrWidget( phoneNrFrame );
    phNrLayout->addWidget(phoneNrWid);
    
    connect( phoneNrWid, SIGNAL(dialNr(const QString&)), this, SLOT(dial(const QString&)));

    ///
    addresseeText->setReadOnly(true);
    addresseeText->setPaletteBackgroundColor(palette().color(QPalette::Normal, QColorGroup::Background));
    vcPicture->setFixedSize(80, 80);
    vcPicture->setPixmap( KGlobal::iconLoader()->loadIcon( "personal", KIcon::Desktop, 128 ) );

}

void VisCard::setByAddressee(KABC::Addressee person)
{
    kdDebug() << "VisCard::setByAddressee()" << endl;
    
    vcName->setText( person.formattedName() );
    
    QString localTime = "Localtime:" + person.timeZone().asString();
    
    QString title = "";
    if( person.title() != "" )
        title = ", "+person.title()+"<br />";
        
    QString role = "";
    if(person.role() != "")
        role = person.roleLabel()+" "+person.role()+"<br />";
        
    QString organization = "";
    if(person.organization() != "")
        organization = person.organizationLabel()+" "+person.organization()+"<br />";
    
    QString prefPostAddress = "";
    KABC::Address address = person.address(64);
    prefPostAddress = address.formattedAddress();

    phoneNrWid->setPhoneNrs( person );
    phoneNrWid->show();
        
    QString vcInfoText = title+role+organization+prefPostAddress;
    vcInfo->setText(vcInfoText);

	vcPicture->setPixmap( person.photo().data() );
    kdDebug() << vcPicture->size()<< endl;
		//vcPicture->setPixmap( KGlobal::iconLoader()->loadIcon( "personal", KIcon::Desktop, 128 ) );
	///
    //QString aString;
    //QMimeSourceFactory::defaultFactory()->setImage(
    //aString += "<table><tr><td><img


}

void VisCard::dial(const QString &nr)
{
    kdDebug() << "VisCard::dial()" << endl;
    
    emit dialNr( nr );
}
